Index: /pjproject/trunk/pjmedia/src/pjmedia/transport_srtp_sdes.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/transport_srtp_sdes.c	(revision 5597)
+++ /pjproject/trunk/pjmedia/src/pjmedia/transport_srtp_sdes.c	(revision 5597)
@@ -0,0 +1,703 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2017 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
+ */
+
+#if defined(PJ_HAS_SSL_SOCK) && (PJ_HAS_SSL_SOCK != 0)
+
+/* Include OpenSSL libraries for MSVC */
+#  ifdef _MSC_VER
+#    if OPENSSL_VERSION_NUMBER >= 0x10100000L
+#      pragma comment(lib, "libcrypto")
+#    else
+#      pragma comment(lib, "libeay32")
+#      pragma comment(lib, "ssleay32")
+#    endif
+#  endif
+
+#endif
+
+static pj_status_t sdes_media_create(pjmedia_transport *tp,
+				     pj_pool_t *sdp_pool,
+				     unsigned options,
+				     const pjmedia_sdp_session *sdp_remote,
+				     unsigned media_index);
+static pj_status_t sdes_encode_sdp  (pjmedia_transport *tp,
+				     pj_pool_t *sdp_pool,
+				     pjmedia_sdp_session *sdp_local,
+				     const pjmedia_sdp_session *sdp_remote,
+				     unsigned media_index);
+static pj_status_t sdes_media_start (pjmedia_transport *tp,
+				     pj_pool_t *pool,
+				     const pjmedia_sdp_session *sdp_local,
+				     const pjmedia_sdp_session *sdp_remote,
+				     unsigned media_index);
+static pj_status_t sdes_media_stop  (pjmedia_transport *tp);
+
+
+static pjmedia_transport_op sdes_op =
+{
+    NULL,
+    NULL,
+    NULL,
+    NULL,
+    NULL,
+    NULL,
+    &sdes_media_create,
+    &sdes_encode_sdp,
+    &sdes_media_start,
+    &sdes_media_stop,
+    NULL,
+    NULL
+};
+
+
+static pj_status_t sdes_create(transport_srtp *srtp,
+			       pjmedia_transport **p_keying)
+{
+    pjmedia_transport *sdes;
+
+    sdes = PJ_POOL_ZALLOC_T(srtp->pool, pjmedia_transport);
+    pj_ansi_strncpy(sdes->name, "SDES", PJ_MAX_OBJ_NAME);
+    sdes->type = PJMEDIA_TRANSPORT_TYPE_SRTP;
+    sdes->op = &sdes_op;
+    sdes->user_data = srtp;
+
+    *p_keying = sdes;
+    PJ_LOG(5,(THIS_FILE, "SRTP keying SDES created"));
+    return PJ_SUCCESS;
+}
+
+
+/* Generate crypto attribute, including crypto key.
+ * If crypto-suite chosen is crypto NULL, just return PJ_SUCCESS,
+ * and set buffer_len = 0.
+ */
+static pj_status_t generate_crypto_attr_value(pj_pool_t *pool,
+					      char *buffer, int *buffer_len,
+					      pjmedia_srtp_crypto *crypto,
+					      int tag)
+{
+    pj_status_t status;
+    int cs_idx = get_crypto_idx(&crypto->name);
+    char b64_key[PJ_BASE256_TO_BASE64_LEN(MAX_KEY_LEN)+1];
+    int b64_key_len = sizeof(b64_key);
+    int print_len;
+
+    if (cs_idx == -1)
+	return PJMEDIA_SRTP_ENOTSUPCRYPTO;
+
+    /* Crypto-suite NULL. */
+    if (cs_idx == 0) {
+	*buffer_len = 0;
+	return PJ_SUCCESS;
+    }
+
+    /* Generate key if not specified. */
+    if (crypto->key.slen == 0) {
+	pj_bool_t key_ok;
+	char key[MAX_KEY_LEN];
+	err_status_t err;
+	unsigned i;
+
+	PJ_ASSERT_RETURN(MAX_KEY_LEN >= crypto_suites[cs_idx].cipher_key_len,
+			 PJ_ETOOSMALL);
+
+	do {
+	    key_ok = PJ_TRUE;
+
+
+#if defined(PJ_HAS_SSL_SOCK) && (PJ_HAS_SSL_SOCK != 0)
+	    err = RAND_bytes((unsigned char*)key,
+			     crypto_suites[cs_idx].cipher_key_len);
+	    if (err != 1) {
+		PJ_LOG(5,(THIS_FILE, "Failed generating random key"));
+		return PJMEDIA_ERRNO_FROM_LIBSRTP(1);
+	    }
+#else	    
+	    err = crypto_get_random((unsigned char*)key,
+				     crypto_suites[cs_idx].cipher_key_len);
+	    if (err != err_status_ok) {
+		PJ_LOG(5,(THIS_FILE, "Failed generating random key: %s",
+			  get_libsrtp_errstr(err)));
+		return PJMEDIA_ERRNO_FROM_LIBSRTP(err);
+	    }
+#endif
+	    for (i=0; i<crypto_suites[cs_idx].cipher_key_len && key_ok; ++i)
+		if (key[i] == 0) key_ok = PJ_FALSE;
+
+	} while (!key_ok);
+	crypto->key.ptr = (char*)
+			  pj_pool_zalloc(pool,
+					 crypto_suites[cs_idx].cipher_key_len);
+	pj_memcpy(crypto->key.ptr, key, crypto_suites[cs_idx].cipher_key_len);
+	crypto->key.slen = crypto_suites[cs_idx].cipher_key_len;
+    }
+
+    if (crypto->key.slen != (pj_ssize_t)crypto_suites[cs_idx].cipher_key_len)
+	return PJMEDIA_SRTP_EINKEYLEN;
+
+    /* Key transmitted via SDP should be base64 encoded. */
+    status = pj_base64_encode((pj_uint8_t*)crypto->key.ptr, crypto->key.slen,
+			      b64_key, &b64_key_len);
+    if (status != PJ_SUCCESS) {
+	PJ_LOG(5,(THIS_FILE, "Failed encoding plain key to base64"));
+	return status;
+    }
+
+    b64_key[b64_key_len] = '\0';
+
+    PJ_ASSERT_RETURN(*buffer_len >= (crypto->name.slen + \
+		     b64_key_len + 16), PJ_ETOOSMALL);
+
+    /* Print the crypto attribute value. */
+    print_len = pj_ansi_snprintf(buffer, *buffer_len, "%d %s inline:%s",
+				   tag,
+				   crypto_suites[cs_idx].name,
+				   b64_key);
+    if (print_len < 1 || print_len >= *buffer_len)
+	return PJ_ETOOSMALL;
+
+    *buffer_len = print_len;
+
+    return PJ_SUCCESS;
+}
+
+
+/* Parse crypto attribute line */
+static pj_status_t parse_attr_crypto(pj_pool_t *pool,
+				     const pjmedia_sdp_attr *attr,
+				     pjmedia_srtp_crypto *crypto,
+				     int *tag)
+{
+    pj_str_t token, delim;
+    pj_status_t status;
+    int itmp, found_idx;
+
+    pj_bzero(crypto, sizeof(*crypto));
+
+    /* Tag */
+    delim = pj_str(" ");
+    found_idx = pj_strtok(&attr->value, &delim, &token, 0);
+    if (found_idx == attr->value.slen) {
+	PJ_LOG(4,(THIS_FILE, "Attribute crypto expecting tag"));
+	return PJMEDIA_SDP_EINATTR;
+    }
+
+    /* Tag must not use leading zeroes. */
+    if (token.slen > 1 && *token.ptr == '0')
+	return PJMEDIA_SDP_EINATTR;
+
+    /* Tag must be decimal, i.e: contains only digit '0'-'9'. */
+    for (itmp = 0; itmp < token.slen; ++itmp)
+	if (!pj_isdigit(token.ptr[itmp]))
+	    return PJMEDIA_SDP_EINATTR;
+
+    /* Get tag value. */
+    *tag = pj_strtoul(&token);
+
+    /* Crypto-suite */
+    found_idx = pj_strtok(&attr->value, &delim, &token, found_idx+token.slen);
+    if (found_idx == attr->value.slen) {
+	PJ_LOG(4,(THIS_FILE, "Attribute crypto expecting crypto suite"));
+	return PJMEDIA_SDP_EINATTR;
+    }
+    pj_strdup(pool, &crypto->name, &token);
+
+    /* Key method */
+    delim = pj_str(": ");
+    found_idx = pj_strtok(&attr->value, &delim, &token, found_idx+token.slen);
+    if (found_idx == attr->value.slen) {
+	PJ_LOG(4,(THIS_FILE, "Attribute crypto expecting key method"));
+	return PJMEDIA_SDP_EINATTR;
+    }
+    if (pj_stricmp2(&token, "inline")) {
+	PJ_LOG(4,(THIS_FILE, "Attribute crypto key method '%.*s' "
+	          "not supported!", token.slen, token.ptr));
+	return PJMEDIA_SDP_EINATTR;
+    }
+
+    /* Key */    
+    delim = pj_str("| ");
+    found_idx = pj_strtok(&attr->value, &delim, &token, found_idx+token.slen);
+    if (found_idx == attr->value.slen) {
+	PJ_LOG(4,(THIS_FILE, "Attribute crypto expecting key"));
+	return PJMEDIA_SDP_EINATTR;
+    }
+    
+    if (PJ_BASE64_TO_BASE256_LEN(token.slen) > MAX_KEY_LEN) {
+	PJ_LOG(4,(THIS_FILE, "Key too long"));
+	return PJMEDIA_SRTP_EINKEYLEN;
+    }
+
+    /* Decode key */
+    crypto->key.ptr = (char*) pj_pool_zalloc(pool, MAX_KEY_LEN);
+    itmp = MAX_KEY_LEN;
+    status = pj_base64_decode(&token, (pj_uint8_t*)crypto->key.ptr,
+			      &itmp);
+    if (status != PJ_SUCCESS) {
+	PJ_LOG(4,(THIS_FILE, "Failed decoding crypto key from base64"));
+	return status;
+    }
+    crypto->key.slen = itmp;
+
+    return PJ_SUCCESS;
+}
+
+
+static pj_status_t sdes_media_create( pjmedia_transport *tp,
+				      pj_pool_t *sdp_pool,
+				      unsigned options,
+				      const pjmedia_sdp_session *sdp_remote,
+				      unsigned media_index)
+{
+    struct transport_srtp *srtp = (struct transport_srtp*)tp->user_data;
+
+    /* Validations */
+    if (srtp->offerer_side) {
+	if (srtp->setting.use == PJMEDIA_SRTP_DISABLED)
+	    srtp->bypass_srtp = PJ_TRUE;
+    } else {
+	pjmedia_sdp_media *m_rem = sdp_remote->media[media_index];
+
+	/* Nothing to do on inactive media stream */
+	if (pjmedia_sdp_media_find_attr(m_rem, &ID_INACTIVE, NULL))
+	    srtp->bypass_srtp = PJ_TRUE;
+
+	/* Validate remote media transport based on SRTP usage option. */
+	switch (srtp->setting.use) {
+	    case PJMEDIA_SRTP_DISABLED:
+		if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) == 0)
+		    return PJMEDIA_SRTP_ESDPINTRANSPORT;
+		srtp->bypass_srtp = PJ_TRUE;
+		break;
+	    case PJMEDIA_SRTP_OPTIONAL:
+		break;
+	    case PJMEDIA_SRTP_MANDATORY:
+		if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) != 0)
+		    return PJMEDIA_SRTP_ESDPINTRANSPORT;
+		break;
+	}
+    }
+
+    return PJ_SUCCESS;
+}
+
+static pj_status_t sdes_encode_sdp( pjmedia_transport *tp,
+				    pj_pool_t *sdp_pool,
+				    pjmedia_sdp_session *sdp_local,
+				    const pjmedia_sdp_session *sdp_remote,
+				    unsigned media_index)
+{
+    struct transport_srtp *srtp = (struct transport_srtp*)tp->user_data;
+    pjmedia_sdp_media *m_rem, *m_loc;
+    enum { MAXLEN = 512 };
+    char buffer[MAXLEN];
+    int buffer_len;
+    pj_status_t status;
+    pjmedia_sdp_attr *attr;
+    pj_str_t attr_value;
+    unsigned i, j;
+
+    m_rem = sdp_remote ? sdp_remote->media[media_index] : NULL;
+    m_loc = sdp_local->media[media_index];
+
+    /* Bypass SDES if media transport is not RTP/AVP or RTP/SAVP */
+    if (pj_stricmp(&m_loc->desc.transport, &ID_RTP_AVP)  != 0 &&
+	pj_stricmp(&m_loc->desc.transport, &ID_RTP_SAVP) != 0)
+    {
+	return PJ_SUCCESS;
+    }
+
+    /* If the media is inactive, do nothing. */
+    /* No, we still need to process SRTP offer/answer even if the media is
+     * marked as inactive, because the transport is still alive in this
+     * case (e.g. for keep-alive). See:
+     *   http://trac.pjsip.org/repos/ticket/1079
+     */
+    /*
+    if (pjmedia_sdp_media_find_attr(m_loc, &ID_INACTIVE, NULL) ||
+	(m_rem && pjmedia_sdp_media_find_attr(m_rem, &ID_INACTIVE, NULL)))
+	goto BYPASS_SRTP;
+    */
+
+    /* Check remote media transport & set local media transport
+     * based on SRTP usage option.
+     */
+    if (srtp->offerer_side) {
+
+	/* Generate transport */
+	switch (srtp->setting.use) {
+	    case PJMEDIA_SRTP_DISABLED:
+		pj_assert(!"Shouldn't reach here");
+		return PJ_SUCCESS;
+	    case PJMEDIA_SRTP_OPTIONAL:
+		m_loc->desc.transport =
+				(srtp->peer_use == PJMEDIA_SRTP_MANDATORY)?
+				ID_RTP_SAVP : ID_RTP_AVP;
+		break;
+	    case PJMEDIA_SRTP_MANDATORY:
+		m_loc->desc.transport = ID_RTP_SAVP;
+		break;
+	}
+
+	/* Generate crypto attribute if not yet */
+	if (pjmedia_sdp_media_find_attr(m_loc, &ID_CRYPTO, NULL) == NULL) {
+	    int tag = 1;
+
+	    /* Offer only current active crypto if any, otherwise offer all
+	     * crypto-suites in the setting.
+	     */
+	    for (i=0; i<srtp->setting.crypto_count; ++i) {
+		if (srtp->tx_policy.name.slen &&
+		    pj_stricmp(&srtp->tx_policy.name,
+			       &srtp->setting.crypto[i].name) != 0)
+		{
+		    continue;
+		}
+
+		buffer_len = MAXLEN;
+		status = generate_crypto_attr_value(srtp->pool, buffer,
+						    &buffer_len,
+						    &srtp->setting.crypto[i],
+						    tag);
+		if (status != PJ_SUCCESS)
+		    return status;
+
+		/* If buffer_len==0, just skip the crypto attribute. */
+		if (buffer_len) {
+		    pj_strset(&attr_value, buffer, buffer_len);
+		    attr = pjmedia_sdp_attr_create(srtp->pool, ID_CRYPTO.ptr,
+						   &attr_value);
+		    m_loc->attr[m_loc->attr_count++] = attr;
+		    ++tag;
+		}
+	    }
+	}
+
+    } else {
+	/* Answerer side */
+
+	pj_assert(sdp_remote && m_rem);
+
+	/* Generate transport */
+	switch (srtp->setting.use) {
+	    case PJMEDIA_SRTP_DISABLED:
+		pj_assert(!"Shouldn't reach here");
+		if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) == 0)
+		    return PJMEDIA_SRTP_ESDPINTRANSPORT;
+		return PJ_SUCCESS;
+	    case PJMEDIA_SRTP_OPTIONAL:
+		m_loc->desc.transport = m_rem->desc.transport;
+		break;
+	    case PJMEDIA_SRTP_MANDATORY:
+		if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) != 0)
+		    return PJMEDIA_SRTP_ESDPINTRANSPORT;
+		m_loc->desc.transport = ID_RTP_SAVP;
+		break;
+	}
+
+	/* Generate crypto attribute if not yet */
+	if (pjmedia_sdp_media_find_attr(m_loc, &ID_CRYPTO, NULL) == NULL) {
+
+	    pjmedia_srtp_crypto tmp_rx_crypto;
+	    pj_bool_t has_crypto_attr = PJ_FALSE;
+	    int matched_idx = -1;
+	    int chosen_tag = 0;
+	    int tags[64]; /* assume no more than 64 crypto attrs in a media */
+	    unsigned cr_attr_count = 0;
+
+	    /* Find supported crypto-suite, get the tag, and assign
+	     * policy_local.
+	     */
+	    for (i=0; i<m_rem->attr_count; ++i) {
+		if (pj_stricmp(&m_rem->attr[i]->name, &ID_CRYPTO) != 0)
+		    continue;
+
+		has_crypto_attr = PJ_TRUE;
+
+		status = parse_attr_crypto(srtp->pool, m_rem->attr[i],
+					   &tmp_rx_crypto,
+					   &tags[cr_attr_count]);
+		if (status != PJ_SUCCESS)
+		    return status;
+
+		/* Check duplicated tag */
+		for (j=0; j<cr_attr_count; ++j) {
+		    if (tags[j] == tags[cr_attr_count]) {
+			DEACTIVATE_MEDIA(sdp_pool, m_loc);
+			return PJMEDIA_SRTP_ESDPDUPCRYPTOTAG;
+		    }
+		}
+
+		if (matched_idx == -1) {
+		    /* lets see if the crypto-suite offered is supported */
+		    for (j=0; j<srtp->setting.crypto_count; ++j)
+			if (pj_stricmp(&tmp_rx_crypto.name,
+				       &srtp->setting.crypto[j].name) == 0)
+			{
+			    int cs_idx = get_crypto_idx(&tmp_rx_crypto.name);
+			    
+	    		    if (cs_idx == -1)
+	    		        return PJMEDIA_SRTP_ENOTSUPCRYPTO;
+
+			    if (tmp_rx_crypto.key.slen !=
+				(int)crypto_suites[cs_idx].cipher_key_len)
+				return PJMEDIA_SRTP_EINKEYLEN;
+
+			    srtp->rx_policy_neg = tmp_rx_crypto;
+			    chosen_tag = tags[cr_attr_count];
+			    matched_idx = j;
+    			    break;
+			}
+		}
+		cr_attr_count++;
+	    }
+
+	    /* Check crypto negotiation result */
+	    switch (srtp->setting.use) {
+		case PJMEDIA_SRTP_DISABLED:
+		    pj_assert(!"Should never reach here");
+		    break;
+
+		case PJMEDIA_SRTP_OPTIONAL:
+		    /* Bypass SDES if remote uses RTP/AVP and:
+		     * - has no crypto-attr, or
+		     * - has no matching crypto
+		     */
+		    if ((!has_crypto_attr || matched_idx == -1) &&
+			pj_stricmp(&m_rem->desc.transport, &ID_RTP_AVP) == 0)
+		    {
+			return PJ_SUCCESS;
+		    }
+		    break;
+
+		case PJMEDIA_SRTP_MANDATORY:
+		    /* Do nothing, intentional */
+		    break;
+	    }
+
+	    /* No crypto attr */
+	    if (!has_crypto_attr) {
+		DEACTIVATE_MEDIA(sdp_pool, m_loc);
+		return PJMEDIA_SRTP_ESDPREQCRYPTO;
+	    }
+
+	    /* No crypto match */
+	    if (matched_idx == -1) {
+		DEACTIVATE_MEDIA(sdp_pool, m_loc);
+		return PJMEDIA_SRTP_ENOTSUPCRYPTO;
+	    }
+
+	    /* we have to generate crypto answer,
+	     * with srtp->tx_policy_neg matched the offer
+	     * and rem_tag contains matched offer tag.
+	     */
+	    buffer_len = MAXLEN;
+	    status = generate_crypto_attr_value(
+					srtp->pool, buffer, &buffer_len,
+					&srtp->setting.crypto[matched_idx],
+					chosen_tag);
+	    if (status != PJ_SUCCESS)
+		return status;
+
+	    srtp->tx_policy_neg = srtp->setting.crypto[matched_idx];
+
+	    /* If buffer_len==0, just skip the crypto attribute. */
+	    if (buffer_len) {
+		pj_strset(&attr_value, buffer, buffer_len);
+		attr = pjmedia_sdp_attr_create(sdp_pool, ID_CRYPTO.ptr,
+					       &attr_value);
+		m_loc->attr[m_loc->attr_count++] = attr;
+	    }
+
+	    /* At this point, we get valid rx_policy_neg & tx_policy_neg. */
+	}
+    }
+
+    return PJ_SUCCESS;
+}
+
+
+static pj_status_t fill_local_crypto(pj_pool_t *pool,
+			             const pjmedia_sdp_media *m_loc, 
+			             pjmedia_srtp_crypto loc_crypto[],
+			             int *count)
+{
+    int i;
+    int crypto_count = 0;
+    pj_status_t status = PJ_SUCCESS;
+    
+    for (i = 0; i < *count; ++i) {
+	pj_bzero(&loc_crypto[i], sizeof(loc_crypto[i]));
+    }
+
+    for (i = 0; i < (int)m_loc->attr_count; ++i) {	
+	pjmedia_srtp_crypto tmp_crypto;
+	int loc_tag;
+
+	if (pj_stricmp(&m_loc->attr[i]->name, &ID_CRYPTO) != 0)
+	    continue;
+
+	status = parse_attr_crypto(pool, m_loc->attr[i],
+				   &tmp_crypto, &loc_tag);
+	if (status != PJ_SUCCESS)
+	    return status;
+
+	if (loc_tag > *count)
+	    return PJMEDIA_SRTP_ESDPINCRYPTOTAG;
+
+	loc_crypto[loc_tag-1] = tmp_crypto;
+	++crypto_count;
+    }
+    *count = crypto_count;
+    return status;
+}
+
+
+static pj_status_t sdes_media_start( pjmedia_transport *tp,
+				     pj_pool_t *pool,
+				     const pjmedia_sdp_session *sdp_local,
+				     const pjmedia_sdp_session *sdp_remote,
+				     unsigned media_index)
+{
+    struct transport_srtp *srtp = (struct transport_srtp*)tp->user_data;
+    pjmedia_sdp_media *m_rem, *m_loc;
+    pj_status_t status;
+    unsigned i;
+    pjmedia_srtp_crypto	loc_crypto[PJMEDIA_SRTP_MAX_CRYPTOS];
+    int loc_cryto_cnt = PJMEDIA_SRTP_MAX_CRYPTOS;
+
+    m_rem = sdp_remote->media[media_index];
+    m_loc = sdp_local->media[media_index];
+
+    if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) == 0)
+	srtp->peer_use = PJMEDIA_SRTP_MANDATORY;
+    else
+	srtp->peer_use = PJMEDIA_SRTP_OPTIONAL;
+
+    /* For answerer side, this function will just have to start SRTP */
+
+    /* Check remote media transport & set local media transport
+     * based on SRTP usage option.
+     */
+    if (srtp->offerer_side) {
+	if (srtp->setting.use == PJMEDIA_SRTP_DISABLED) {
+	    if (pjmedia_sdp_media_find_attr(m_rem, &ID_CRYPTO, NULL)) {
+		DEACTIVATE_MEDIA(pool, m_loc);
+		return PJMEDIA_SRTP_ESDPINCRYPTO;
+	    }
+	    return PJ_SUCCESS;
+	} else if (srtp->setting.use == PJMEDIA_SRTP_OPTIONAL) {
+	    // Regardless the answer's transport type (RTP/AVP or RTP/SAVP),
+	    // the answer must be processed through in optional mode.
+	    // Please note that at this point transport type is ensured to be
+	    // RTP/AVP or RTP/SAVP, see sdes_media_create()
+	    //if (pj_stricmp(&m_rem->desc.transport, &m_loc->desc.transport)) {
+		//DEACTIVATE_MEDIA(pool, m_loc);
+		//return PJMEDIA_SDP_EINPROTO;
+	    //}
+	    fill_local_crypto(srtp->pool, m_loc, loc_crypto, &loc_cryto_cnt);
+	} else if (srtp->setting.use == PJMEDIA_SRTP_MANDATORY) {
+	    if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP)) {
+		DEACTIVATE_MEDIA(pool, m_loc);
+		return PJMEDIA_SDP_EINPROTO;
+	    }
+	    fill_local_crypto(srtp->pool, m_loc, loc_crypto, &loc_cryto_cnt);
+	}
+    }
+
+    if (srtp->offerer_side) {
+	/* find supported crypto-suite, get the tag, and assign policy_local */
+	pjmedia_srtp_crypto tmp_tx_crypto;
+	pj_bool_t has_crypto_attr = PJ_FALSE;
+	int rem_tag;
+	int j;
+
+	for (i=0; i<m_rem->attr_count; ++i) {
+	    if (pj_stricmp(&m_rem->attr[i]->name, &ID_CRYPTO) != 0)
+		continue;
+
+	    /* more than one crypto attribute in media answer */
+	    if (has_crypto_attr) {
+		DEACTIVATE_MEDIA(pool, m_loc);
+		return PJMEDIA_SRTP_ESDPAMBIGUEANS;
+	    }
+
+	    has_crypto_attr = PJ_TRUE;
+
+	    status = parse_attr_crypto(srtp->pool, m_rem->attr[i],
+				       &tmp_tx_crypto, &rem_tag);
+	    if (status != PJ_SUCCESS)
+		return status;
+
+
+	    /* Tag range check, our tags in the offer must be in the SRTP 
+	     * setting range, so does the remote answer's. The remote answer's 
+	     * tag must not exceed the tag range of the local offer.
+	     */
+	    if (rem_tag < 1 || rem_tag > (int)srtp->setting.crypto_count ||
+		rem_tag > loc_cryto_cnt) 
+	    {
+		DEACTIVATE_MEDIA(pool, m_loc);
+		return PJMEDIA_SRTP_ESDPINCRYPTOTAG;
+	    }
+
+	    /* match the crypto name */
+	    if (pj_stricmp(&tmp_tx_crypto.name, &loc_crypto[rem_tag-1].name))
+	    {
+		DEACTIVATE_MEDIA(pool, m_loc);
+		return PJMEDIA_SRTP_ECRYPTONOTMATCH;
+	    }
+
+	    /* Find the crypto from the setting. */
+	    for (j = 0; j < (int)srtp->setting.crypto_count; ++j) {
+		if (pj_stricmp(&tmp_tx_crypto.name, 
+			       &srtp->setting.crypto[j].name) == 0) 
+		{
+		    srtp->tx_policy_neg = srtp->setting.crypto[j];
+		    break;
+		}		
+	    }
+
+	    srtp->rx_policy_neg = tmp_tx_crypto;
+	}
+
+	if (srtp->setting.use == PJMEDIA_SRTP_DISABLED) {
+	    /* should never reach here */
+	    return PJ_SUCCESS;
+	} else if (srtp->setting.use == PJMEDIA_SRTP_OPTIONAL) {
+	    if (!has_crypto_attr)
+		return PJ_SUCCESS;
+	} else if (srtp->setting.use == PJMEDIA_SRTP_MANDATORY) {
+	    if (!has_crypto_attr) {
+		DEACTIVATE_MEDIA(pool, m_loc);
+		return PJMEDIA_SRTP_ESDPREQCRYPTO;
+	    }
+	}
+
+	/* At this point, we get valid rx_policy_neg & tx_policy_neg. */
+    }
+
+    return PJ_SUCCESS;
+}
+
+static pj_status_t sdes_media_stop(pjmedia_transport *tp)
+{
+    PJ_UNUSED_ARG(tp);
+    return PJ_SUCCESS;
+}
Index: /pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 5596)
+++ /pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 5597)
@@ -56,6 +56,7 @@
     unsigned		media_options;	/**< Transport media options.	    */
     void	       *user_data;	/**< Only valid when attached	    */
-    pj_bool_t		attached;	/**< Has attachment?		    */
+    //pj_bool_t		attached;	/**< Has attachment?		    */
     pj_sockaddr		rem_rtp_addr;	/**< Remote RTP address		    */
+    unsigned		rem_rtp_cnt;	/**< How many pkt from this addr.   */
     pj_sockaddr		rem_rtcp_addr;	/**< Remote RTCP address	    */
     int			addr_len;	/**< Length of addresses.	    */
@@ -480,9 +481,14 @@
 		/* We're still receiving from rem_rtp_addr. Don't switch. */
 		udp->rtp_src_cnt = 0;
+		udp->rem_rtp_cnt++;
 	    } else {
 		udp->rtp_src_cnt++;
 
 		if (udp->rtp_src_cnt < PJMEDIA_RTP_NAT_PROBATION_CNT) {
-		    discard = PJ_TRUE;
+		    /* Only discard if we have ever received packet from
+		     * remote address (rem_rtp_addr).
+		     */
+		    //discard = PJ_TRUE;
+		    discard = (udp->rem_rtp_cnt != 0);
 		} else {
 		
@@ -530,5 +536,6 @@
 	}
 
-	if (!discard && udp->attached && cb)
+	//if (!discard && udp->attached && cb)
+	if (!discard && cb)
 	    (*cb)(user_data, udp->rtp_pkt, bytes_read);
 
@@ -566,5 +573,6 @@
 	user_data = udp->user_data;
 
-	if (udp->attached && cb)
+	//if (udp->attached && cb)
+	if (cb)
 	    (*cb)(user_data, udp->rtcp_pkt, bytes_read);
 
@@ -650,5 +658,5 @@
 
     /* Must not be "attached" to existing application */
-    PJ_ASSERT_RETURN(!udp->attached, PJ_EINVALIDOP);
+    //PJ_ASSERT_RETURN(!udp->attached, PJ_EINVALIDOP);
 
     /* Lock the ioqueue keys to make sure that callbacks are
@@ -686,5 +694,5 @@
 
     /* Last, mark transport as attached */
-    udp->attached = PJ_TRUE;
+    //udp->attached = PJ_TRUE;
 
     /* Reset source RTP & RTCP addresses and counter */
@@ -693,4 +701,5 @@
     udp->rtp_src_cnt = 0;
     udp->rtcp_src_cnt = 0;
+    udp->rem_rtp_cnt = 0;
 
     /* Set buffer size for RTP socket */
@@ -752,5 +761,6 @@
     pj_assert(tp);
 
-    if (udp->attached) {
+    //if (udp->attached) {
+    if (1) {
 	int i;
 
@@ -768,5 +778,5 @@
 
 	/* First, mark transport as unattached */
-	udp->attached = PJ_FALSE;
+	//udp->attached = PJ_FALSE;
 
 	/* Clear up application infos from transport */
@@ -801,5 +811,5 @@
 
     /* Must be attached */
-    PJ_ASSERT_RETURN(udp->attached, PJ_EINVALIDOP);
+    //PJ_ASSERT_RETURN(udp->attached, PJ_EINVALIDOP);
 
     /* Check that the size is supported */
@@ -862,5 +872,5 @@
     pj_status_t status;
 
-    PJ_ASSERT_RETURN(udp->attached, PJ_EINVALIDOP);
+    //PJ_ASSERT_RETURN(udp->attached, PJ_EINVALIDOP);
 
     if (addr == NULL) {
Index: /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 5596)
+++ /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 5597)
@@ -707,5 +707,6 @@
      * to connect the call's media to sound device. When ICE is used,
      * this callback will also be called to report ICE negotiation
-     * failure.
+     * failure. When DTLS-SRTP is used, this callback will also be called
+     * to report DTLS negotiation failure.
      *
      * @param call_id	The call index.
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 5596)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 5597)
@@ -1275,4 +1275,5 @@
 	const pjmedia_sdp_media *m = sdp->media[i];
 	const pjmedia_sdp_conn *c;
+	static const pj_str_t ID_RTP_SAVP = { "RTP/SAVP", 8 };
 
 	/* Skip different media */
@@ -1285,5 +1286,5 @@
 
 	/* Supported transports */
-	if (pj_stricmp2(&m->desc.transport, "RTP/SAVP")==0) {
+	if (pj_stristr(&m->desc.transport, &ID_RTP_SAVP)) {
 	    switch (use_srtp) {
 	    case PJMEDIA_SRTP_MANDATORY:
@@ -1494,4 +1495,32 @@
 }
 
+
+/* This callback is called when SRTP negotiation completes */
+static void on_srtp_nego_complete(pjmedia_transport *tp, 
+				  pj_status_t result)
+{
+    pjsua_call_media *call_med = (pjsua_call_media*)tp->user_data;
+    pjsua_call *call;
+
+    if (!call_med)
+	return;
+
+    call = call_med->call;
+    PJ_PERROR(4,(THIS_FILE, result,
+		 "Call %d: Media %d: SRTP negotiation completes",
+	         call->index, call_med->idx));
+
+    if (result != PJ_SUCCESS) {
+	call_med->state = PJSUA_CALL_MEDIA_ERROR;
+	call_med->dir = PJMEDIA_DIR_NONE;
+	if (call && pjsua_var.ua_cfg.cb.on_call_media_state) {
+	    /* Defer the callback to a timer */
+	    pjsua_schedule_timer2(&ice_failed_nego_cb,
+				  (void*)(pj_ssize_t)call->index, 1);
+	}
+    }
+}
+
+
 /* Callback to resume pjsua_call_media_init() after media transport
  * creation is completed.
@@ -1547,4 +1576,6 @@
 	pjmedia_srtp_setting_default(&srtp_opt);
 	srtp_opt.close_member_tp = PJ_TRUE;
+	srtp_opt.cb.on_srtp_nego_complete = &on_srtp_nego_complete;
+	srtp_opt.user_data = call_med;
 
 	/* If media session has been ever established, let's use remote's 
